<?php

declare(strict_types=1);

namespace Drupal\graphql_compose_webform\Plugin\GraphQLCompose\SchemaType;

use Drupal\graphql_compose\Plugin\GraphQLCompose\GraphQLComposeSchemaTypeBase;
use GraphQL\Type\Definition\ObjectType;
use GraphQL\Type\Definition\Type;

/**
 * {@inheritDoc}
 *
 * @GraphQLComposeSchemaType(
 *   id = "WebformConfirmation"
 * )
 */
class WebformConfirmation extends GraphQLComposeSchemaTypeBase {

  /**
   * {@inheritDoc}
   */
  public function getTypes(): array {
    $types = [];

    // Add the "WebformElement" type.
    $types[] = new ObjectType([
      'name' => $this->getPluginId(),
      'description' => (string) $this->t('A webform confirmation.'),
      'fields' => fn() => [
        'confirmation_type' => Type::string(),
        'confirmation_url' => Type::string(),
        'confirmation_title' => Type::string(),
        'confirmation_message' => Type::string(),
        'confirmation_attributes' => Type::listOf(Type::string()),
        'confirmation_back' => Type::boolean(),
        'confirmation_back_label' => Type::string(),
        'confirmation_back_attributes' => Type::listOf(Type::string()),
        'confirmation_exclude_query' => Type::boolean(),
        'confirmation_exclude_token' => Type::boolean(),
        'confirmation_update' => Type::boolean(),
      ],
    ]);

    return $types;
  }

}
